#include <stdio.h>
#include <malloc.h>
#include <string.h>

#include "uc.h"
#include "lists.h"


/******************************************************************
   List add/del/check
******************************************************************/

NAMELIST *lst_add(list, name)
NAMELIST *list;
char *name;
{
   NAMELIST *new;

   if ((new=(NAMELIST *)malloc(sizeof(NAMELIST))) == NULL)
      return(list);

   if ((new->fname=strdup(name)) == NULL)
   {
      free(new);
      return(list);
   }   

   new->next = list;
   list = new;
   
   return(list);   
}


NAMELIST *lst_del(list, name)
NAMELIST *list;
char *name;
{
   NAMELIST *prev, *this, *next;

   prev = NULL;
   this = list;
   while (this != NULL)
   {
      next = this->next;
      if (strcmp(this->fname, name) == 0)
      {
         if (prev == NULL)
            list = this->next;
         else
            prev->next = this->next;   
         free(this->fname);
         free(this);
      }
      this = next;
   }
   
   return(list);
}


lst_exists(list, name)
NAMELIST *list;
char *name;
{
   NAMELIST *this;

   this = list;
   while (this != NULL)
   {
      if (strcmp(this->fname, name) == 0)
         return(1);
      this = this->next;
   }

   return(0);
}


